import QtQuick

ListModel {
    id: root

    function createAndLoadComponent(item) {
        var newObj = Qt.createComponent("CustomDataModel.qml").createObject(root)
        newObj.parseObject(item)
        return newObj
    }

    function extractValue(value) {
        if (Array.isArray(value))
            return parseArray(value)
        else if (value.constructor === ({}).constructor)
            return createAndLoadComponent(value)
        else
            return value
    }

    function parseArray(value) {
        var arr = []
        for (var i = 0; i < value.length; i++)
            arr.push({[""]: extractValue(value[i])})
        return arr
    }

    function parseObject(json) {
        for (var key in json)
            root.append({[key]: extractValue(json[key])})
    }
}
