import QtQuick
import QtQuick.Controls

ListView {
    id: root
    property var customModel
    function createObjectElement(prop, rootId) {
        return Qt.createQmlObject(`
              import QtQuick
              import QtQuick.Controls
              import QtQuick.Layouts
              GridLayout {
                  property alias childsId: childsId
                  columns: 2
                  Button { text: childsId.visible ? "-" : "+"
                           onClicked: childsId.visible = !childsId.visible }
                  Text { text: "${prop}:" }
                  Item {}
                  ColumnLayout { id: childsId }}`, rootId)
    }

    function prepareNestedElements(prop, rootId, value, ifArray) {
        var child = createObjectElement(prop, rootId)
        for (var i = 0; i < value.count; i++)
            createView(value.get(i), child.childsId, ifArray ? null : i)
    }

    function createView(item, rootId, index) {
        let count = 0;
        for (var prop in item)
            if ((index !== undefined && index !== null && index !== count++) || !item[prop]) {
            } else if (item[prop] instanceof ListModel && !(item[prop] instanceof CustomDataModel)) {
                prepareNestedElements(prop, rootId, item[prop], true)
            } else if (item[prop].constructor === ({}).constructor) {
                prepareNestedElements(prop, rootId, item[prop], false)
            } else {
                var middle = prop === "" ? "" : ": "
                Qt.createQmlObject(`
                    import QtQuick
                    Row {
                        Item { width: 20; height: 10 }
                        Text { text: "${prop}${middle}${item[prop]}" }}`, rootId
                )
            }
    }
    model: customModel
    delegate: Column {
        id: colId
        Component.onCompleted: root.createView(customModel.get(index), colId)
    }
}
